# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

#
# Ubuntu System Tests
# Copyright (C) 2015 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import logging
import os
import signal
import subprocess

logger = logging.getLogger(__name__)


def is_process_running(pname):
    try:
        return get_process_id(pname) != 0
    except:
        return False


def get_process_id(pname):
    return int(subprocess.check_output(['pidof', pname]))


def stop_process(pname):
    if is_process_running(pname):
        pid = get_process_id(pname)
        os.kill(pid, signal.SIGKILL)
