# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

#
# Ubuntu System Tests
# Copyright (C) 2015 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from autopilot import exceptions


class MusicScope():

    def __init__(self, music_scope):
        self.scope = music_scope

    def is_album(self, album):
        """ Determines if there is an album with the desired name in the
        current scope
        :param album: The name of the desired album
        :return: True is there is an album with the desired name, False
        otherwise
        """
        try:
            self.scope.select_single('AbstractButton', title=album)
            return True
        except exceptions.StateNotFoundError:
            return False
