# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

#
# Ubuntu System Tests
# Copyright (C) 2015 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3,
# as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import logging

import autopilot
import ubuntuuitoolkit

from ubuntu_system_tests.helpers.autopilot import override_proxy_timeout

logger = logging.getLogger(__name__)


class Notifications(ubuntuuitoolkit.UbuntuUIToolkitCustomProxyObjectBase):

    def get_current_notification(self, timeout=60):
        with override_proxy_timeout(self, timeout):
            return self.wait_select_single(
                'Notification',
                objectName='notification1'
            )


class Notification(ubuntuuitoolkit.UbuntuUIToolkitCustomProxyObjectBase):

    @autopilot.logging.log_action(logger.info)
    def tap_on(self):
        self.pointing_device.click_object(
            self.select_single(objectName="interactiveArea")
        )

    @autopilot.logging.log_action(logger.info)
    def press_ok(self):
        ok_buttons = self.select_many('Button', text='Ok')
        if ok_buttons:
            self.pointing_device.click_object(ok_buttons[0])


class DownloadFinishedNotification(Notification):

    def get_open_button(self):
        return self.select_single('Button', objectName='notify_button0')
